
/* todoist functions */

todoist_get_tasks = function(){
	
	var data = { "token" : token, 'resource_types' : '["projects"]'};
	
	jQuery.ajax({
		url: url,
		data: data,
		type: "POST",
		dataType: "json",
		success: function(response) {
			console.log("API request succeded");
			console.log(response);
			sync_token = response.sync_token;
		},
		error: function(response) { 
			console.log("API request failed");
			console.log(response);
		},
	});
	
}

todoist_add_project = function(project_name) {
	
	var resource_types = '["projects"]';
	
	var commands = [{
		"type": "project_add",
		"temp_id": temp_id,
		"uuid": uuid,
		"args": {
			"name": project_name
		}
	}];
	
	var commands = JSON.stringify(commands);
	
	var data = {
		"token" : token,
		'sync_token' : sync_token,
		'resource_types' : resource_types,
		'commands' : commands
	};
	
	jQuery.ajax({
		url: url,
		data: data,
		type: "POST",
		dataType: "json",
		success: function(response) {
			console.log("API request succeded");
			sync_token = response.sync_token;
		},
		error: function(response) { 
			console.log("API request failed");
			console.log("error");
		},
	});
	
}

todoist_tasks_to_commands = function(tasks) {
	
	var commands = [];
	
	tasks.forEach(function(args) {
		
		var temp_commands = {
			"type": "item_add",
			"temp_id": guid(),
			"uuid": guid(),
			"args": args
		};

		commands.push(temp_commands)

	});
	
	commands = JSON.stringify(commands);
	
	return commands;
	
}

var split_count = 50;
var n = 0;
var max = 0;
var tasks = {};
var start = 0;
var end = split_count;
var fail_count = 0;
var stop = false;

todoist_add_tasks = function(new_tasks) {
	
	// Set variables
	
	tasks = new_tasks;
	stop = false;
	n = Math.round(tasks.length / split_count);
	max = tasks.length;
	if(end > max) end = max;
	
	console.log("Add tasks to todoist ...");
	
	myjq_log("Add " + tasks.length + " tasks to Todoist.");
		
	todoist_add_tasks_slicer();
	
}

todoist_add_tasks_slicer = function() {
	
	if(max <= start) stop = true;
	
	if(stop) return;
	
	myjq_log("Take slice from " + start + " to " + end);
	
	// Take a slice
	
	task_slice = tasks.slice(start, end);
	
	// Feed the slice to todoist

	todoist_add_tasks_ajax(task_slice);
	
}

todoist_add_tasks_counter = function() {
	
	// Update counters
	
	start = end;
	
	end = end + split_count;
	
	if(end > max) {
		end = max;
	}
	
	fail_count = 0;
	
}

todoist_add_tasks_ajax = function(task_slice) {
	
	myjq_log("Run todoist Api request");
	
	var resource_types = '["projects", "items"]';
		
	var commands = todoist_tasks_to_commands(task_slice);
	
	var data = {
		"token" : token,
		'sync_token' : sync_token,
		'resource_types' : resource_types,
		'commands' : commands
	};
	
	
	jQuery.ajax({
		url: url,
		data: data,
		type: "POST",
		dataType: "json",
		success: function(response) {
			
			todoist_add_tasks_counter();
			myjq_log("Todoist Api request succeded.");
			console.log(response);
			todoist_add_tasks_slicer();
			
		},
		error: function(response) { 
		
			fail_count = fail_count + 1;
			if(fail_count > 3) stop = true;
			myjq_log("Todoist Api request failed.");
			console.log(response);	
			todoist_add_tasks_slicer();
			
		},
	});
	
	
	
}

/* General functions */

function guid() {
  function s4() {
    return Math.floor((1 + Math.random()) * 0x10000)
      .toString(16)
      .substring(1);
  }
  return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
    s4() + '-' + s4() + s4() + s4();
}

jQuery.urlParam = function(name){
    var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results==null){
       return null;
    }
    else{
       return decodeURI(results[1]) || 0;
    }
}

/* Google functions */

gsheets_get = function(id) {
	
	console.log("Ask google for data ...");
	
	Tabletop.init( { key: id, callback: gsheets_tasks_callback, simpleSheet: true } )
}

gsheets_tasks_callback = function (tasks) {
	
  console.log("Google sheet data received ...");
  console.log(tasks);
  todoist_add_tasks(tasks);
  
}

// Global variables
	
var url = "https://todoist.com/api/v7/sync";
var token = "";
var sync_token = "*";
var t;

/* Trigger */

document.addEventListener('DOMContentLoaded', function() {
    
	var google_sheet_id = jQuery.urlParam("id");
	jQuery("#gid").val(google_sheet_id);
	
	console.log("The google sheet id is: " + google_sheet_id);
	
	token = jQuery.urlParam("token");
	jQuery("#token").val(token);
	
	console.log("The Todoist token is: " + token);
	gsheets_get(google_sheet_id);
	
}, false);
